;(function($){
    var $adp,adper,args={},icon,loaded,delaytime;
    var queuePlayOff = 0; //队列播放开关（冲突检测时用）
    $.fn.audioPlayer = function(options) {
        // stopPlay(); //如果正在播放，则停止播放和动画
        args = $.extend({}, $.fn.audioPlayer.defaults, options);
        return this.each(function() {
            icon = this;
            adper.src = args.url;
            loaded = 0;
            if(args.callbackType == 1){
                delaytime = 0;
            }
            adper.load();
        });
    };
    // 默认参数
    $.fn.audioPlayer.defaults = {
        "url" : null,
        "autoPlay": 0,
        "callbackType": 0,
        "tracePlay": 0,
    };
    // 开放接口方法
    $.audioPlayer = ({
        play:function(){ //播放
            adper.play();
        },
        pause:function(){ //暂停
            adper.pause();
        },
        stopPlay:function(){ //音频播放事件冲突操作
            stopPlay();
        },
        emptyIcon:function(){ //清空icon对象
            icon = null;
        },
        playerPause:function(){ //播放器暂停调用方法
            playerPause();
        },
        ifAdpPaused:function(){ //播放器是否暂停
            return adper.paused;
        },
        playOrPause:function(){ //播放或暂停
            if(adper.paused){
                adper.play();
                return;
            }
            adper.pause();
        },
        autoPlay:function(a){ //是否自动播放
            args.autoPlay = a;
        },
        reLoad:function(){ //重新加载
            adper.load();
            loaded = 0;
        },
        getDelaytime:function(){ //返回delaytime的值
            return delaytime;
        },
        getProgress:function(){ //返回播放进度
            return adper.currentTime/adper.duration;
        },
        getDuration:function(){
            return adper.duration;
        },
        isHandleMe:function(obj){ //是否正在处理我的请求
            return icon == obj;
        },
        getQueuePlayOff:function(){ //获取 queuePlayOff 的值
            return queuePlayOff;
        },
        setQueuePlayOff:function(a){ //设置 queuePlayOff 的值
            queuePlayOff = a;
        },
        getCallbackType:function(){ //获取 callbackType 的值
            return args.callbackType;
        },
        getArgTracePlay:function(){ //获取 args.tracePlay 的值
            return args.tracePlay;
        }
    });

    //初始化
    init();
    function init(){
        creatAudioPlayer(); //创建音频播放器
        audioEventListener(); //为播放器添加事件监听
    }
    //创建音频播放器
    function creatAudioPlayer(){
        var htmlText = '<audio src="./audio/demo.mp3" id="audioPlayer">您的浏览器不支持音频标签！</audio>';
        $('body').append(htmlText);
        $adp = $('#audioPlayer');
        adper = $adp[0];
        $(document).one("touchstart",function(e){ //无权限时，激活播放器
            if(!auth){
                adper.play();
            }
        });
    }
    //为播放器添加事件监听
    function audioEventListener(){
        $adp.on('canplay',function(){
            loaded = 1;
            if(queuePlayOff == 1 && args.tracePlay == 1){
                args.autoPlay = 0;
            }
            queuePlayOff = 0;
            if(args.autoPlay){
                args.autoPlay = 0;
                this.play();
            }
            if(args.callbackType == 1){
                //设置 delaytime，控制录音自动停止的延迟时间
                if(!delaytime){
                    delaytime = adper.duration * 2000;
                    if(delaytime > 100000){
                        if(adper.paused){
                            adper.currentTime = 0.01;
                            setTimeout(function(){
                                delaytime = adper.duration * 2000;
                            },200);
                        }
                        else {
                            setTimeout(function(){
                                delaytime = adper.duration * 2000;
                            },100);
                        }
                    }
                }
            }
        });
        $adp.on('playing',function(){
            if(args.callbackType == 1){
                if(delaytime == 0){
                    setTimeout(function(){
                        delaytime = adper.duration * 2000;
                    },100);
                }
                $.iconAnimate.playSoundAniStart(icon);
            }
            else if(args.callbackType == 2){
                $.iconAnimate.listeningAniStart(icon);
            }
            else if(args.callbackType == 3){
                $.iconAnimate.dialoAniStart(icon);
            }
        });
        $adp.on('pause',function(){
            playerPause();
        });
        $adp.on('ended',function(){
            if(args.callbackType == 1){
                $.iconAnimate.playSoundAniStop(icon);
                $.commFun.tracePlayQueue(icon);
            }
            else if(args.callbackType == 2){
                $.iconAnimate.listeningAniStop(icon);
            }
            else if(args.callbackType == 3){
                $.iconAnimate.dialoAniStop(icon);
            }
        });
        $adp.on('stalled',function(){
            if(!loaded){
                loaded = 0;
                args.autoPlay = 1;
                this.load();
            }
        });
        $adp.on('error',function(){
            if((args.callbackType == 1) && (this.error.code == 4) && (this.getAttribute('src'))){
                var btnG = $(icon).parent();
                btnG.addClass('error');
                btnG.attr('skipPlay', 1);
            }
        });
    }
    //暂停监听器调用方法
    function playerPause(){
        if(args.callbackType == 1){
            $.iconAnimate.playSoundAniStop(icon);
        }
        else if(args.callbackType == 2){
            $.iconAnimate.listeningAniStop(icon);
        }
        else if(args.callbackType == 3){
            $.iconAnimate.dialoAniStop(icon);
        }
    }
    //如果正在播放，则停止播放和动画
    function stopPlay(){
        if(args.callbackType == 1){
            queuePlayOff = 1; //跳到队列下一个时，禁止自动播放
        }
        if(!adper.paused){
            adper.pause();
            playerPause();
        }
    }
})(Zepto);