/////////////////////////////////生词本/////////////////////////////////////////////////////////////////////
/* 生词本模块：
*   定义 添加生词本方法 addScb , 成功添加回调方法 onScbSuccess
*/
/////////////////////////////////生词本/////////////////////////////////////////////////////////////////////

/* 添加生词本
 * 参数格式json:
 * jsonData = {
 *     "uwid":"",                                 //uwid
 *     "successCallback":"onScbSuccess",         //成功回调函数
 * }
 */
function addScb(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    try{ dictcn.addScb(JSON.stringify({'uwid':uwid,'successCallback':'onScbSuccess'})); }catch(e){}
}
/* 生词本添加成功
 * 参数格式json:
 * jsonData = {
 *     "uwid":"",                                 //uwid
 *     "in_scb": "1/0"
 * }
 */
function onScbSuccess(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var in_scb = jsonData.in_scb || 0;
    $.commFun.refreshStarIconStatus(uwid,in_scb);
}

//////////////////////////// usefull functions //////////////////////////////////////////////
// 解析json
function parseJson(jsonData){
    try{if(jsonData && !isJson(jsonData)) jsonData = JSON.parse(jsonData);}catch(e){}
    return jsonData;
}
//判断是否json对象
function isJson(obj){
    var isjson = typeof(obj) == "object" && Object.prototype.toString.call(obj).toLowerCase() == "[object object]" && !obj.length;
    return isjson;
}
////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////// 学习类应用新增方法 //////////////////////////////////////////////
/* 学习类应用新增方法 模块：
*   定义
*/
//////////////////////////// 学习类应用新增方法 //////////////////////////////////////////////


/* 用户设置保存函数
 * 参数格式json:
 * jsonData = {
 *     "":"",                                 //
 * }
 */
//写入和读取 页面缓存
function setStorage(jsonData) {
    jsonData = parseJson(jsonData);
    var key = jsonData.key || "";
    var value;
    if(isJson(jsonData.value)){
        value = JSON.stringify(jsonData.value) || "";
    }
    else {
        value = jsonData.value || "";
    }
    try{ dictcn.setItem(JSON.stringify({'key':key, 'value':value})); }catch(e){}
}
function getStorage(jsonData) {
    jsonData = parseJson(jsonData);
    var key = jsonData.key || "";
    var successCallback = jsonData.successCallback || "";
    try{ dictcn.getItem(JSON.stringify({'key':key, 'successCallback':successCallback})); }catch(e){}
}
// getStorage 函数回调函数
function onPageID(json){
    json = parseJson(json);
    $.commFun.pageIDInit(json);
}
//getStorage 方法回调函数（读取当前考卷已保存的全部答案）
function getAllAnswer(jsonData){
    jsonData = parseJson(jsonData);
    paperAnswer = parseJson(jsonData.value) || {}; //json
    $.commFun.getAllAnswerInit();
}

/** 录音功能模块
*   方法：
*       startRecord  （开始录音方法）
*       onStartRecord  （开始录音后的回调方法）
*       stopRecord  （停止录音方法）
*       onStopRecord  （停止录音后的回调方法）
*/
//录音功能
function startRecord(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    try{ dictcn.startRecord(JSON.stringify({'uwid':uwid,'successCallback':'onStartRecord'})); }catch(e){}
}
function onStartRecord(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || 0;
    if(uwid){
        $.commFun.startRecordEvent(uwid);
    }
}
//停止录音
function stopRecord(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var invaild = jsonData.invaild || "";
    try{ dictcn.stopRecord(JSON.stringify({'uwid':uwid, "invaild":invaild,'successCallback':'onStopRecord'})); }catch(e){}
}
function onStopRecord(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || 0;
    var filePath = jsonData.filePath || 0;
    if(uwid){
        $.commFun.stopRecordEvent(uwid,filePath);
    }    
}

/** 更新录音播放按钮状态模块
*   参数：
*       
*   方法：
*       refreshRecordPath （更新录音播放按钮状态）
*       onRefreshRecordPath （更新录音播放按钮状态 回调函数）
*/
//更新录音播放按钮状态
function refreshRecordPath(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    try{ dictcn.refreshRecordPath(JSON.stringify({'uwid':uwid,'successCallback':'onRefreshRecordPath'})); }catch(e){}
}
function onRefreshRecordPath(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var filePath = jsonData.filePath || "";
    if(filePath){
        $.commFun.refreshListenSoundBtn(uwid, filePath);
    }
}

//更新添加到生词本按钮状态
function refreshFavorite(jsonData){
    jsonData = parseJson(jsonData);
     var uwid = jsonData.uwid || "";
     try{ dictcn.refreshFavorite(JSON.stringify({'uwid':uwid,'successCallback':'onRefreshFavorite'})); }catch(e){}
}
function onRefreshFavorite(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var isFavorite = jsonData.isFavorite || 0;//1|0
    $.commFun.refreshStarIconStatus(uwid,isFavorite);
}

/** 跳转到单元练习
*   参数：
*       
*   方法：
*       openLesson （跳转到单元练习）
*/
//跳转到单元练习
function openLesson(jsonData){
    jsonData = parseJson(jsonData);
    var lesson_key = jsonData.lesson_key || "";
    try{ dictcn.openLesson(JSON.stringify({'lesson_key':lesson_key})); }catch(e){}
}

/** 调用激活面板
*   参数：
*       
*   方法：
*       noticeToActivate （更新录音播放按钮状态）
*/
function noticeToActivate(){
    try{ dictcn.noticeToActivate(); }catch(e){}
}

/** js开给native接口：更新权限参数isActivate
*   参数：
*       status //标记状态的数值
*   方法：
*       refreshActivate （更新录音播放按钮状态）
*/
function refreshActivate(jsonData){
    jsonData = parseJson(jsonData);
    var status = jsonData.status;
    if(status >= 0){
    	isActivate = status;
    }
}

/**反馈当前打开词条信息给客户端
*   参数：
*       id  //pageID
*       uwid  //当前词条uwid
*       state： “1/0”  //是否已学习
*/
function refreshStudyStatus(jsonData){
    jsonData = parseJson(jsonData);
     var id = jsonData.id || "";
     var uwid = jsonData.uwid || "";
     var state = "1";
     try{ dictcn.refreshStudyStatus(JSON.stringify({'id':id, 'uwid':uwid, 'state':state})); }catch(e){}
}

//屏幕重新唤醒时 native 调用音频 reload方法
function audioReLoad(){
    if(isPlayingAll){
        if($.audioPlayer.getProgress() == 0){
            $.commFun.isPlayingAllTest();
            $.audioPlayer.reLoad();
        }
    }
}

/** 调用native参数设置面板模块
*   参数：
*       
*   方法：
*       openPrmSettingPanel （调用native参数设置面板方法）
*       onRefreshPrmSetting （调用native参数设置面板方法 回调函数）
*/
//调用native参数设置面板方法
function openPrmSettingPanel(){
    var parameterSetting = $.commFun.getPrmSettingArgu();
    try{ dictcn.openPrmSettingPanel(JSON.stringify({'parameterSetting':parameterSetting,'successCallback':'onRefreshPrmSetting'})); }catch(e){}
}
function onRefreshPrmSetting(jsonData){
    jsonData = parseJson(jsonData);
    $.commFun.refreshPrmSetting(jsonData);
}

/* 保存 currKtIndex
 * saveCurrKtIndex方法参数：
 * {
 * "paperID": "" 
 * "currKtIndex": "6"  
 * }
 */
 function saveCurrKtIndex(jsonData){
    jsonData = parseJson(jsonData);
    var paperID = jsonData.paperID || "";
    var currKtIndex = jsonData.currKtIndex;
    if(currKtIndex != 0 && !currKtIndex){
        currKtIndex = "";
    }
    try{ dictcn.saveCurrKtIndex(JSON.stringify({'paperID': paperID, 'currKtIndex': currKtIndex})); }catch(e){}
 }

 /* 询问客户端是否有权限播放音频
 * requestSoundAuth方法参数：
 * {
 * "uwid": ""
 * "callbackType": ""
 * }
 * replySoundAuth
 * {
 * "uwid": ""
 * "auth": "1/0"
 * "callbackType": ""
 * }
 */
 function requestSoundAuth(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var callbackType = jsonData.callbackType || "";
    try{ dictcn.requestSoundAuth(JSON.stringify({'uwid': uwid, 'callbackType':callbackType, 'successCallback':'replySoundAuth'})); }catch(e){}
    // replySoundAuth({"uwid":uwid, "callbackType":callbackType, "auth":"1"});
 }
 //请求音频播放权限回调方法
 function replySoundAuth(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var auth = jsonData.auth || "";
    var callbackType = jsonData.callbackType || "";
    var sen = $('.sentence.active');
    var btn = $("#"+uwid).prev()[0];
    btn.reqauth = 0; //标记按钮未请求权限
    if(sen.attr('name') != uwid) return;
    if(auth == "1"){
        //有权限，播放音频
        if(callbackType == "1" || callbackType == "6"){
            $.audioPlayer.play();
        }
        else if(callbackType == "2"){
            $.commFun.loadNewAudio(btn,1);
        }
        else if(callbackType == "3"){
            $.commFun.loadNewAudio(btn,1);
            skipGivenSen(sen); //判断是否需要跳过当前句子
        }
        else if(callbackType == "4"){
            $.audioPlayer.autoPlay(1);
            $.audioPlayer.reLoad();
            skipGivenSen(sen); //判断是否需要跳过当前句子
        }
        else if(callbackType == "5"){
            $.commFun.replayQueueAudio();
            skipGivenSen(sen); //判断是否需要跳过当前句子
        }
    }
    else {
        //无权限，其它操作
        if(callbackType == "3" || callbackType == "4" || callbackType == "5" || callbackType == "6"){
            $.commFun.playAllSoundInit();
        }
    }
 }
 //连续播放时，判断是否需要跳过特定句子
 function skipGivenSen(sen){
    if(sen.find('.btnGroup').attr('skipPlay')){
        $.commFun.keepPlaying();
    }
 }