;(function($){
    var autoStopRecord; //自动两倍延时关闭录音标记
    var recordAudioPath = {}; //记录录音文件路径
    var lesson_filter = {"lesson_filter":3}; // 中、日标题显示设置参数
    var init_Index = 0; // 上次使用最后打开的句子【当前页】
    var learnEnd = {}; //已学句子标红设置【当前页】
    var learnNum = 0; //已经学习的句子数目
    var senlen = $('.sentence').length; //总句子数目
    var pageObj = {}; //记录pageID项目下设置的对象
    var allPlayPosition = [0,senlen-1]; //全部播放时的播放起止位置
    var wordOrDefine = 1; //只播放单词声音(1) 或 播放单词加释义声音(2)
    var playQueue = []; //音频播放队列
    var allPlayTime = 1; //全部播放的循环次数
    var surplusPlayTime; //全部播放的剩余播放次数
    var keepPlay = 0; //是否继续播放下一条

    $.commFun = ({
        getLessonFilter:function(){
            return lesson_filter;
        },
        getSenlen:function(){
            return senlen;
        },
        getAllPlayPosition:function(){
            return allPlayPosition;
        },
        getWordOrDefine:function(){
            return wordOrDefine;
        },
        getAllPlayTime:function(){
            return allPlayTime;
        },
        setPlayQueue:function(value){
            playQueue = value;
        },
        tracePlayQueue:function(icon){ //播放队列跟踪
            tracePlayQueue(icon);
        },
        playAllSoundInit:function(){ //playAllSound 按钮初始化
            playAllSoundInit();
        },
        showSentence:function(sen,first){ //句子弹开与关闭
            showSentence(sen,first);
        },
        loadNewAudio:function(icon,autoPlay){ //加载新音频资源
            loadNewAudio(icon,autoPlay);
        },
        swipeToCur:function(){ //跳转到当前打开句子方法
            swipeToCur();
        },
        startRecordEvent:function(uwid){ //开始录音执行方法
            startRecordEvent(uwid);
        },
        closeAutoStopRecord:function(){ //关闭两倍延时自动调用的方法
            closeAutoStopRecord();
        },
        stopRecordEvent:function(uwid,filePath){ //停止录音方法
            stopRecordEvent(uwid,filePath);
        },
        getRecordAudioPath:function(index){ //获取index对应录音路径
            return recordAudioPath[index];
        },
        refreshListenSoundBtn:function(uwid, filePath){ //更新播放录音状态
            refreshListenSoundBtn(uwid, filePath);
        },
        refreshStarIconStatus:function(uwid,in_scb){ //更新收藏五角星按钮样式
            refreshStarIconStatus(uwid,in_scb);
        },
        refreshPrmSetting:function(jsonData){ //弹出native设置面板后更新参数设置方法
            refreshPrmSetting(jsonData);
        },
        pageIDInit:function(json){ //获取当前页面ID对应参数后初始化
            pageIDInit(json);
        },
        clickConflictTest:function(){ //点击事件冲突检测方法
            clickConflictTest();
        },
        isPlayingAllTest:function(){ //isPlayingAll冲突检测
            isPlayingAllTest();
        },
        getPrmSettingArgu:function(){ //获取打开设置面板初始参数
            return prmSettingArguAsse();
        },
        keepPlaying:function(){ //继续播放下一条方法
            keepPlaying();
        },
        replayQueueAudio:function(){ //重新播放队列音频（wordOrDefine == 2）
            replayQueueAudio();
        },
    });
    //播放队列跟踪
    function tracePlayQueue(icon){
        var nextAudio = playQueue.shift();
        if(nextAudio){
            var url = audioPrefix + nextAudio;
            $(icon).audioPlayer({"url":url, "autoPlay":1, "callbackType":1, "tracePlay":1});
        }
        else {
            if(keepPlay){
                setTimeout(keepPlaying, 500);
            }
            else {
                if(wordOrDefine == 1){
                    if(!isIOS){
                        $.audioPlayer.reLoad();
                    }
                }
                else if(wordOrDefine == 2){
                    playQueue.push(wordAudioPath[curIndex],pahAudioPath[curIndex]);
                    var url = audioPrefix + playQueue.shift();
                    $(icon).audioPlayer({"url":url, "callbackType":1});
                }
            }
        }
    }
    //继续播放下一条方法
    function keepPlaying(){
        if(curIndex < allPlayPosition[1]){
            var id = curIndex+1;
            var sen = $('.sentence')[id];
            showSentence(sen,0,1);
            swipeToCur();
            if(auth && $('.sentence.active').find('.btnGroup').attr('skipPlay')){
                keepPlaying();
            }
        }
        else if(curIndex == allPlayPosition[1]) {
            if(--surplusPlayTime == 0){
                $.audioPlayer.reLoad();
                playAllSoundInit();
            }
            else {
                if(allPlayPosition[0] != allPlayPosition[1]){
                    showSentence($('.sentence')[allPlayPosition[0]],0,1);
                    swipeToCur();
                }
                else {
                    //继续播放当前词条
                    if(wordOrDefine == 1){
                        if(!auth){
                            var sen = $('.sentence.active');
                            var btn = sen.find('.playSound')[0];
                            if(!btn.reqauth){
                                btn.reqauth = 1;
                                requestSoundAuth({"uwid": sen.attr('name'), "callbackType": "4"});
                            }
                        }
                        else {
                            $.audioPlayer.autoPlay(1);
                            $.audioPlayer.reLoad();
                        }
                    }
                    else if(wordOrDefine == 2){
                        if(!auth){
                            var sen = $('.sentence.active');
                            var btn = sen.find('.playSound')[0];
                            if(!btn.reqauth){
                                btn.reqauth = 1;
                                requestSoundAuth({"uwid": sen.attr('name'), "callbackType": "5"});
                            }
                        }
                        else {
                            replayQueueAudio();
                        }
                    }
                }
                if(auth && $('.sentence.active').find('.btnGroup').attr('skipPlay')){
                    keepPlaying();
                }
            }
        }
    }
    //重新播放队列音频（wordOrDefine == 2）
    function replayQueueAudio(){
        playQueue.push(wordAudioPath[curIndex],pahAudioPath[curIndex]);
        var url = audioPrefix + playQueue.shift();
        var icon = $('.sentence.active').find('.playSound')[0];
        $(icon).audioPlayer({"url":url, "autoPlay":1, "callbackType":1});
    }
    //playAllSound 按钮初始化
    function playAllSoundInit(){
        var This = $('#playAllSound');
        surplusPlayTime = allPlayTime;
        if(!isPlayingAll) {
            clickConflictTest();
            $.audioPlayer.setQueuePlayOff(0); //将队列播放开关参数重置
            $(This).addClass('playing');
            isPlayingAll = 1;
            //判断是否跳转
            if((curIndex < allPlayPosition[0] || curIndex >= allPlayPosition[1]) && (!((allPlayPosition[0] == allPlayPosition[1]) && (curIndex == allPlayPosition[1])))){ //在curIndex不在播放范围内，或在播放范围末尾，且开始位置不等于结束位置的情况下
                    showSentence($('.sentence')[allPlayPosition[0]],0,1); //跳转到起始位置
            }
            else { //未跳转，直接在当前句子播放
                var sen = $('.sentence')[curIndex];
                var pSbtn = $(sen).find('.playSound')[0];
                //判断是否需要替换链接
                if($.audioPlayer.isHandleMe(pSbtn)) { //不需要
                    if($.audioPlayer.ifAdpPaused()){
                        var prog = $.audioPlayer.getProgress();
                        var dura = $.audioPlayer.getDuration(); //处理魅族类手机 bug
                        if(!auth && isNaN(prog) && isNaN(dura)){ //找不到音频，跳过当前句子
                            keepPlaying();
                        }
                        else {
                            if(!auth && (prog < 0.02 || (isNaN(prog) && dura <= 0) || prog == 1)){
                                if(!pSbtn.reqauth){ //未处于请求权限状态
                                    pSbtn.reqauth = 1;
                                    requestSoundAuth({"uwid": $(sen).attr('name'), "callbackType": "6"});
                                }
                            }
                            else {
                                $.audioPlayer.play();
                            }
                        }
                    }
                }
                else { //需要
                    if(!auth){
                        if(!pSbtn.reqauth){ //未处于请求权限状态
                            pSbtn.reqauth = 1;
                            requestSoundAuth({"uwid": $(sen).attr('name'), "callbackType": "3"});
                        }
                    }
                    else {
                        loadNewAudio(pSbtn,1);
                    }
                }
            }
            swipeToCur();
            if(auth){
                //判断是否需要跳过当前句子
                if($('.sentence.active').find('.btnGroup').attr('skipPlay')){
                    keepPlaying();
                }
            }
            keepPlay = 1;
        }
        else {
            $(This).removeClass('playing');
            isPlayingAll = 0;
            keepPlay = 0;
            $.audioPlayer.pause();
        }
    }
    
    //句子弹开与关闭
    function showSentence(sen,first,playAll) {
        lastIndex = curIndex;
        curIndex = $(sen).index();
        //判断两次点击是否是同一条句子，分情况处理
        if(curIndex == lastIndex){
            $(sen).removeClass('active');
            $(sen).find('.xieyin').addClass('hide');
            $.audioPlayer.pause();
            $.audioPlayer.emptyIcon();
            curIndex = -1;
        }
        else {
            if (lastIndex >= 0) {
                var oldSen = $('.sentence')[lastIndex];
                $(oldSen).removeClass('active');
                $(oldSen).find('.xieyin').addClass('hide');
                $.audioPlayer.playerPause();
            }
            $(sen).addClass('active');
            //判断录音数据是否已存在、生词本是否已添加
            var uwid = $(sen).attr('name');
            var json = {"uwid": uwid};
            refreshRecordPath(json);
            refreshFavorite(json);
            $(sen).find('.xieyin').removeClass('hide');
            var btn = $(sen).find('.playSound')[0];
            if(first){
                // $(sen).find('.progressIcon').hide();
                if(auth){
                    loadNewAudio(btn,0);
                }
            }
            else {
                if(!auth){
                    btn.reqauth = 1;
                    if(playAll){
                        requestSoundAuth({"uwid": uwid, "callbackType": "3"});
                    }
                    else{
                        requestSoundAuth({"uwid": uwid, "callbackType": "2"});
                    }
                }
                else {
                    loadNewAudio(btn,1);
                }
            }
        }
        scrollContainer[0].resizeFix(1);
        //处理已学习记录的样式变化
        if(curIndex >= 0 && !(learnEnd[curIndex])){
            $(sen).find('.senTitle').addClass('redcolor');
            learnEnd[curIndex] = 1;
            learnNum++;
            $('#progress').css({'-webkit-transform': 'scaleX('+learnNum/senlen+')'});
            if(learnNum == senlen){
                $('#progress').addClass('full');
            }
        }
        init_Index = curIndex;
        pageObj.init_Index = init_Index;
        pageObj.learnEnd = learnEnd;
        setStorage({"key":pageID, "value":pageObj});

        if(lesson_filter.lesson_filter == 2){
            activeRi(sen,"only-ri");
        }
        else if(lesson_filter.lesson_filter == 1){
            activeRi(sen,"only-zhong");
        }

        //反馈当前打开词条信息给客户端
        var json = {};
        json.id = pageID;
        json.uwid = $(sen).attr('name');
        refreshStudyStatus(json);
    }
    //处理只显示日文情况下，active变化的问题
    function activeRi(sen,className){
        if(curIndex >= 0) {
            var senTW = $(sen).find('.senTitleWord')[0];
            $(senTW).removeClass(className);
            if(className == "only-ri"){
                swapHtmlText(senTW);
            }
            if(lastIndex >= 0) {
                var oldSen = $('.sentence')[lastIndex];
                var senTW = $(oldSen).find('.senTitleWord')[0];
                $(senTW).addClass(className);
                if(className == "only-ri"){
                    swapHtmlText(senTW);
                }
            }
        }
        else {
            var senTW = $(sen).find('.senTitleWord')[0];
            $(senTW).addClass(className);
            if(className == "only-ri"){
                swapHtmlText(senTW);
            }
        }
    }
    //html文本互换
    function swapHtmlText(senTW){
        var htmlText = $(senTW).find('.zhong').html();
        $(senTW).find('.zhong').html($(senTW).find('.ri').html());
        $(senTW).find('.ri').html(htmlText);
    }
    //为 playSound 按钮 加载新音频资源
    function loadNewAudio(icon,autoPlay){
        playQueue = [];
        if(wordOrDefine == 1){
            playQueue.push(wordAudioPath[curIndex]);
        }
        else if(wordOrDefine == 2){
            playQueue.push(wordAudioPath[curIndex],pahAudioPath[curIndex]);
        }
        var url = audioPrefix + playQueue.shift();
        $(icon).audioPlayer({"url":url, "autoPlay":autoPlay, "callbackType":1});
    }

    //跳转到当前打开句子方法
    function swipeToCur(){
        var dis = 0;
        for(var i = 0; i < curIndex; i++){
            dis += $($('.sentence')[i]).height();
        }
        scrollContainer[0].setWrapperTranslate(0, -dis,0);
    }
    //开始录音执行方法
    function startRecordEvent(uwid){
        isRecord = 1;
        $.iconAnimate.recordAudioAniStart(uwid);
        //两倍播放时间后自动停止录音
        var delaytime = $.audioPlayer.getDelaytime();
        if(!delaytime){
            delaytime = 6000;
        }
        autoStopRecord = setTimeout(function(){
            // var uwid = $('.sentence.active').attr('name');
            var json = {'uwid': uwid};
            json.invaild = 1;
            stopRecord(json);
        }, delaytime);
    }
    //关闭两倍延时自动调用的方法
    function closeAutoStopRecord(){
        clearTimeout(autoStopRecord);
    }
    //停止录音方法
    function stopRecordEvent(uwid,filePath){
        isRecord = 0;
        //清除录音按钮动画
        $.iconAnimate.recordAudioAniStop();
        var btn = $("#"+uwid)[0];
        btn.state = 0; //标记按钮接收点击事件
        $(btn).removeClass('work ani1 ani2 ani3 ani4 ani5');
        if(filePath){
            if($.audioPlayer.getCallbackType() == 2){
                $.audioPlayer.emptyIcon();
            }
            refreshListenSoundBtn(uwid, filePath);
        }
    }
    //更新播放录音状态
    function refreshListenSoundBtn(uwid, filePath){
        var btn = $("#"+uwid).parent();
        //显示播放录音按钮，并为 recordVoice 声音标签设置声音链接
        var listenBtn = btn.find('.listenSound');
        var index = btn.attr('index')-1;
        $(listenBtn).removeClass('hide');
        recordAudioPath[index] = filePath;
    }
    //更新收藏五角星按钮样式
    function refreshStarIconStatus(uwid,in_scb){
        var star = $('#'+uwid).parent().find('.addStar');
        if(in_scb == '1'){
            $(star).addClass('inscb');
        }
        else if(in_scb == '0') {
            $(star).removeClass('inscb');
        }
    }
    //弹出native设置面板后更新参数设置方法
    function refreshPrmSetting(jsonData){
        if(jsonData.allPlayPosition){
            //用户保存设置
            var arr = jsonData.allPlayPosition;
            allPlayPosition = [];
            for(var i = 0; i < arr.length; i++){
                allPlayPosition.push(arr[i]-1);
            }
            if(wordOrDefine != jsonData.wordOrDefine){
                wordOrDefine = jsonData.wordOrDefine;
                playQueue = [];
                if(wordOrDefine == 1){
                    playQueue.push(wordAudioPath[curIndex]);
                }
                else if(wordOrDefine == 2){
                    playQueue.push(wordAudioPath[curIndex],pahAudioPath[curIndex]);
                }
                var url = audioPrefix + playQueue.shift();
                var icon = $('.sentence.active').find('.playSound')[0];
                if(icon){
                    $(icon).audioPlayer({"url":url, "callbackType":1});
                }
            }
            allPlayTime = parseInt(jsonData.allPlayTime);
            var lastFilter = lesson_filter.lesson_filter;
            lesson_filter = jsonData.lesson_filter;
            senTitleWordInit(lastFilter); //中、日显示切换
            //保存新设置进localstorage
            pageObj.allPlaySetting = {"allPlayPosition": allPlayPosition, "wordOrDefine": wordOrDefine, "allPlayTime": allPlayTime};
            pageObj.lesson_filter = lesson_filter;
            setStorage({"key":pageID, "value":pageObj});
        }
        else {
            //用户放弃设置
        }
    }
    //中、日显示初始化
    function senTitleWordInit(lastFilter){
        //根据上次保存设置初始化
        if(lastFilter != lesson_filter.lesson_filter) {
            senTitleWordChange(lesson_filter.lesson_filter);
            if(lesson_filter.lesson_filter == 1){
                scrollContainer[0].resizeFix(1);
                swipeToCur();
                $('.senNum').removeClass('zhongri');
            }
            else if(lesson_filter.lesson_filter == 3){
                scrollContainer[0].resizeFix(1);
                swipeToCur();
                $('.senNum').addClass('zhongri');
            }
        }
    }
    //定义中、日或是中+日  id值可能是：1（中）、2（日）、3（中+日）
    function senTitleWordChange(id) {
        if(id){
            if (id==1) {
                $('.senTitleWord').each(function(){
                    $(this).removeClass('only-ri');
                    $(this).addClass('only-zhong');
                });
            }
            else if(id==2){
                $('.senTitleWord').each(function(){
                    $(this).removeClass('only-zhong');
                    $(this).addClass('only-ri');
                });
            }
            else if (id==3) {
                $('.senTitleWord').each(function(){
                    $(this).removeClass('only-zhong');
                    $(this).removeClass('only-ri');
                });
            }

            $('.sentence.active').find('.senTitleWord').each(function(){
                $(this).removeClass('only-ri only-zhong');
            });
        }
    }
    //获取当前页面ID对应参数后初始化
    function pageIDInit(json){
        if(!json.value){
            for(var i = 0; i < senlen; i++){
                learnEnd[i] = 0;
            }
            pageObj.learnEnd = learnEnd;
            pageObj.init_Index = init_Index;
            pageObj.lesson_filter = lesson_filter;
            pageObj.allPlaySetting = {"allPlayPosition": allPlayPosition, "wordOrDefine": wordOrDefine, "allPlayTime": allPlayTime};
            setStorage({"key":pageID, "value":pageObj});
        }
        else {
            var pageSet = parseJson(json.value);
            init_Index = pageSet.init_Index;
            learnEnd = pageSet.learnEnd;
            lesson_filter = pageSet.lesson_filter;
            var allPlaySetting = parseJson(pageSet.allPlaySetting);
            allPlayPosition = allPlaySetting.allPlayPosition;
            wordOrDefine = allPlaySetting.wordOrDefine;
            allPlayTime = allPlaySetting.allPlayTime;
            //初始化pageObj的所有字段
            pageObj.learnEnd = learnEnd;
            pageObj.init_Index = init_Index;
            pageObj.lesson_filter = lesson_filter;
            pageObj.allPlaySetting = allPlaySetting;
        }
        senTitleWordInit(0); //中、日显示初始化
        for(var j in learnEnd){
            if(learnEnd[j] == 1){
                $($('.sentence')[j]).find('.senTitle').addClass('redcolor');
                learnNum++;
            }
        }
        $('#progress').css({'-webkit-transform': 'scaleX('+learnNum/senlen+')'});
        if(learnNum == senlen){
            $('#progress').addClass('full');
        }
        //根据auto_uwid跳转
        if(auto_uwid && (auto_uwid != "0")) {
            showSentence($('#'+auto_uwid).parents('.sentence'), 1);
            swipeToCur();
        }
        //根据用户上次打开的句子跳转
        else if (init_Index >= 0) {
            showSentence($('.sentence')[init_Index], 1);
            swipeToCur();
        }
    }

    //----------------冲突检测------------------
    //点击事件冲突检测方法
    function clickConflictTest(){
        $.audioPlayer.stopPlay(); //停止播放器及对应动画
        if(isRecord){
            var uwid = $('.sentence.active').attr('name');
            var json = {'uwid': uwid};
            json.invaild = 0;
            stopRecord(json);
            closeAutoStopRecord();
            isRecord = 0;
        }
        isPlayingAllTest();
    }
    //isPlayingAll冲突检测
    function isPlayingAllTest(){
        if(isPlayingAll){
            $('#playAllSound').removeClass('playing');
            isPlayingAll = 0;
            keepPlay = 0;
            $.audioPlayer.stopPlay(); //停止播放器及对应动画
        }
    }

    //----------------其他特殊方法------------------
    //设置面板参数拼装方法
    function prmSettingArguAsse(){
        var playPosition = [];
        for(var i = 0; i < allPlayPosition.length; i++){
            playPosition.push(parseInt(allPlayPosition[i])+1);
        }
        return {"allPlayPosition": playPosition,"wordOrDefine": wordOrDefine,"allPlayTime": allPlayTime,"lesson_filter": lesson_filter,"maxNum": senlen};
    }
})(Zepto);