;(function($){
    var init_Index = 0; // 上次使用最后打开的句子【习题一】
    var learnEnd = []; //已学句子标红设置【习题一】
    var lastIndex = -1, curIndex = -1; //记录上次打开和当前打开的句子
    var optionArray = ["A","B","C","D","E","F","G"]; //选项表

    $.commFun = ({
        assembleHtml:function(data,ktID,serNum){ //组装数据通用代码方法
            return assembleHtml(data,ktID,serNum);
        },
        getAllAnswerInit:function(){ //获取全部答案后初始化
            getAllAnswerInit();
        },
        pageIDInit:function(json){ //获取当前页面ID对应参数后初始化
            pageIDInit(json);
        },
        showSentence:function(sen){ //习题一展开单词
            showSentence(sen);
        },
    });
    
    //组装数据通用代码方法
    function assembleHtml(data,ktID,serNum){
        var htmlText = '';
        htmlText = '<div class="swiper-slide" id="'+ ktID +'">';
        htmlText += assembleInnerHtml(data,ktID,serNum);
        htmlText += '</div>';
        return htmlText;
    }
    //拼装swiper-slide内部html文本
    function assembleInnerHtml(data,ktID,serNum){
        var key = paperID+'_'+ktID;
        var htmlText = '<div class="dropShadow"></div><div class="innerCard"><div class="testTitle"><div class="testNum">'+ (serNum+1) +'</div><div class="testTitleCon">'+ data.question +'</div></div><div class="testOption">';
        var Data = data.option;
        for(var i=0; i<optionArray.length; i++){
            if(Data[optionArray[i]]){
                if(paperAnswer[key] && (paperAnswer[key] == optionArray[i])) {
                    if(paperAnswer[key] == data.answer){
                        htmlText += '<div class="mylabel right" key="'+ optionArray[i] +'"><span>'+ optionArray[i] +'</span>'+ Data[optionArray[i]] +'</div>';
                    }
                    else {
                        htmlText += '<div class="mylabel wrong" key="'+ optionArray[i] +'"><span>'+ optionArray[i] +'</span>'+ Data[optionArray[i]] +'</div>';
                    }
                }
                else {
                    htmlText += '<div class="mylabel" key="'+ optionArray[i] +'"><span>'+ optionArray[i] +'</span>'+ Data[optionArray[i]] +'</div>';
                }
            }
            else {
                break;
            }
        }
        htmlText += '</div><p class="rightAnswer';
        if(paperAnswer[key] && (paperAnswer[key] != data.answer)){
            htmlText += ' show';
        }
        htmlText += '">正确答案是: <span class="rightColor">'+ data.answer +'</span></p></div>';
        return htmlText;
    }

    //获取全部答案后初始化
    function getAllAnswerInit(){
        // 初始化进度统计
        for(var i in paperAnswer){
            if(paperAnswer[i]){
                learnNum++;
                proMask[i] = 1;
            }
        }
        $('#progress').css({'-webkit-transform': 'scaleX('+learnNum/ktNum+')'});
        if(learnNum == ktNum){
            $('#progress').addClass('full');
        }
        //更新当前页面三道题的答案状态
        $('#trainingTwo .swiper-slide').each(function(){
            var ktID = $(this).attr('id');
            var key = paperID +'_'+ ktID;
            if(paperAnswer[key]){
                $(this).find('.mylabel').each(function(){
                    if(paperAnswer[key] == $(this).attr('key')){
                        if($(this).find('answer').length){
                            $(this).addClass('right');
                        }
                        else {
                            $(this).addClass('wrong');
                            $(this).parent().next().addClass('show');
                        }
                    }
                });
            }
        });
    }

    //获取当前页面ID对应参数后初始化
    function pageIDInit(json){
        if(!json.value){
            for(var i = 0; i < $('.wordExercise').length; i++){
                learnEnd[i] = 0;
            }
            pageObj.learnEnd = learnEnd;
            pageObj.init_Index = init_Index;
            pageObj.trainType = trainType;
            setStorage({"key":paperID, "value":pageObj});
        }
        else {
            var pageSet = parseJson(json.value);
            init_Index = pageSet.init_Index;
            learnEnd = pageSet.learnEnd;
            trainType = pageSet.trainType;

            //初始化 pageObj
            pageObj.learnEnd = learnEnd;
            pageObj.init_Index = init_Index;
            pageObj.trainType = trainType;
        }
        //更新已学过的习题一样式
        for(var j in learnEnd){
            if(learnEnd[j] == 1){
                $($('.wordExercise')[j]).addClass('read');
                learnNum++;
            }
        }
        $('#progress').css({'-webkit-transform': 'scaleX('+learnNum/ktNum+')'});
        if(learnNum == ktNum){
            $('#progress').addClass('full');
        }
        
        //根据用户上次打开的句子跳转
        if (init_Index >= 0) {
            showSentence($('.wordExercise')[init_Index]);
            click_scroll($('.wordExercise')[init_Index]);
        }

        //根据 trainType 跳转习题类型
        if(trainType){
            swiperMain.slideTo(trainType,300);
        }
    }
    //页面跳转
    function click_scroll(aim) {
        var scroll_offset = $(aim).offset().top-$(aim).height();
        $(".innerContent").scrollTop(scroll_offset);
    }

    //习题一展开单词
    function showSentence(sen){
        lastIndex = curIndex;
        curIndex = $(sen).index();
        //判断两次点击是否是同一条句子，分情况处理
        if(curIndex == lastIndex){
            $(sen).removeClass('active');
            curIndex = -1;
        }
        else {
            $($('.wordExercise')[lastIndex]).removeClass('active');
            $(sen).addClass('active read');
            if(!learnEnd[curIndex]){
                learnEnd[curIndex] = 1;
                learnNum++;
                $('#progress').css({'-webkit-transform': 'scaleX('+learnNum/ktNum+')'});
                if(learnNum == ktNum){
                    $('#progress').addClass('full');
                }
            }
        }
        init_Index = curIndex;
        pageObj.init_Index = init_Index;
        pageObj.learnEnd = learnEnd;
        setStorage({"key":paperID, "value":pageObj});
        //反馈当前打开词条信息给客户端
        var json = {};
        json.id = paperID;
        json.uwid = $(sen).attr('id');
        refreshStudyStatus(json);
    }
})(Zepto);