/******************************************************************************
 *
 *  建立命名空间
 *
 ******************************************************************************/
//建立一级域名
var cn;
if(!cn) cn = {};

//建立二级域名
if(!cn.dict) cn.dict = {};

/**
 *
 *  API版本号
 *
 */
cn.dict.version = 2.0;

/******************************************************************************
 *
 *  私有方法和变量
 *
 ******************************************************************************/
var __giframeId__ = 1;

function __createIFrameId__() {
    return "__native_iframe_hidden_" + (__giframeId__ ++);
}

function __createHiddenIFrame__() {
    var iframe = document.createElement("iframe");
    iframe.id = __createIFrameId__();
    iframe.style.display = 'none';
    return iframe;
}

function __createNaviteURL__(commServiceUrl,module,action,iframeId,jsonString) {
    var url = commServiceUrl;
    if(module)
        url += "&" + "module=" + module;
    if(action)
        url += "&" + "action=" + action;
    if(iframeId)
        url += "&" + "iframeId=" + iframeId;
    if(jsonString)
        url += "&" + "jsonString=" + encodeURIComponent(jsonString);
    return url;
}


/******************************************************************************
 *
 *  native service模块
 *
 ******************************************************************************/
if(!cn.dict.NaitveServiceManager) cn.dict.NaitveServiceManager = {};
//协议名
cn.dict.NaitveServiceManager.PROTOCOL = "native";

//公共服务url
cn.dict.NaitveServiceManager.COMMON_SERVICE_URL = cn.dict.NaitveServiceManager.PROTOCOL + "://" + "common" +  "?" + "version=" + cn.dict.version;
cn.dict.NaitveServiceManager.ScbModuleName = "scb";
cn.dict.NaitveServiceManager.AudioModuleName = "audio";
cn.dict.NaitveServiceManager.UIModuleName = "ui";
cn.dict.NaitveServiceManager.DictionaryModuleName = "dictionary";
cn.dict.NaitveServiceManager.LsManagerModuleName = "lesson";

//全局快捷访问方式
var _gCommonServiceUrl = cn.dict.NaitveServiceManager.COMMON_SERVICE_URL;

/******************************************************************************
 *
 *  生词本管理模块
 *
 ******************************************************************************/
//建立生词本管理模块
if(!cn.dict.ScbManager) cn.dict.ScbManager = {}
/**
 添加生词本单词
 
 @param  jsonString: 参数列表数据
 
 格式：
 jsonString = {
 "wid":"",                                 //wid
 "successCallback":"onScbSuccess",         //成功回调函数
 "failedCallback":"onScbFailed"            //失败回调函数
 }
 
 @return void
 */
cn.dict.ScbManager.addScb = function(jsonString) {
    var actionName = "addScb";
    var iframeElement = __createHiddenIFrame__();
    iframeElement.src = __createNaviteURL__(_gCommonServiceUrl,cn.dict.NaitveServiceManager.ScbModuleName,actionName,iframeElement.id,jsonString);
    document.body.appendChild(iframeElement);
}

//生词本快捷访问对象
var _ScbMgr = cn.dict.ScbManager;

/******************************************************************************
 *
 *  发音管理模块
 *
 ******************************************************************************/
/* 本地播放声音
 * 参数格式json:
 * jsonData = {
 *     "lang":"b",                                 //语种
 *     "key":"tuaminoheptane",                    //word
 *     "scode":"QG",                              //scode
 *     "url":"url"                                //mp3地址，支持url发音
 *     "startPlaySound":"startPlaySound",         //开始播放动画js回调
 *     "endPlaySound":"endPlaySound"              //停止播放动画js回调
 * }
 */
function playSound(jsonData){
    try{ dictcn.playSound(JSON.stringify({'lang':'k','key':jsonData.key,'scode':jsonData.scode})); }catch(e){}
}
//建立声音管理模块
if(!cn.dict.AudioManager) cn.dict.AudioManager = {}

/* 本地播放声音
 * 参数格式json:
 * jsonData = {
 *     "lang":"b",                                 //语种
 *     "key":"tuaminoheptane",                    //word
 *     "scode":"QG",                              //scode
 *     "url":"url"                                //mp3地址，支持url发音
 *     "startCallback":"onStartPlaySound",         //开始播放动画js回调
 *     "endCallback":"onEndPlaySound"              //停止播放动画js回调
 * }
 */
cn.dict.AudioManager.playSound = function(jsonString) {
    var actionName = "playSound";
    var iframeElement = __createHiddenIFrame__();
    iframeElement.src = __createNaviteURL__(_gCommonServiceUrl,cn.dict.NaitveServiceManager.AudioModuleName,actionName,iframeElement.id,jsonString);
    document.body.appendChild(iframeElement);
}

//生词本快捷访问对象
var _AudioMgr = cn.dict.AudioManager;

/******************************************************************************
 *
 *  词典管理模块
 *
 ******************************************************************************/
//建立词典管理模块
if(!cn.dict.DictionaryManager) cn.dict.DictionaryManager = {}

/**
 是否存在笔顺动画
 key:  查询关键字
 successCallback: 回调，返回笔顺动画的数据
 failureCallback: 不存在回调
 */
cn.dict.DictionaryManager.getStrokeOrder = function(jsonString) {
    var actionName = "getStrokeOrder";
    var iframeElement = __createHiddenIFrame__();
    iframeElement.src = __createNaviteURL__(_gCommonServiceUrl,cn.dict.NaitveServiceManager.DictionaryModuleName,actionName,iframeElement.id,jsonString);
    document.body.appendChild(iframeElement);
}

/**
 屏幕取词调用
 */
cn.dict.DictionaryManager.popupDict = function(jsonString) {
    var actionName = "popupDict";
    var iframeElement = __createHiddenIFrame__();
    iframeElement.src = __createNaviteURL__(_gCommonServiceUrl,cn.dict.NaitveServiceManager.DictionaryModuleName,actionName,iframeElement.id,jsonString);
    document.body.appendChild(iframeElement);
}


//词典快捷访问对象
var _DictMgr = cn.dict.DictionaryManager;

/******************************************************************************
 *
 *  UI控制模块
 *
 ******************************************************************************/
//建立生词本管理模块
if(!cn.dict.UIManager) cn.dict.UIManager = {}

/**
 查词跳转
 jsonString 格式
 
 {
 "text" : "查词关键字"
 }
 */
cn.dict.UIManager.searchWord = function(jsonString) {
    var actionName = "searchWord";
    var iframeElement = __createHiddenIFrame__();
    iframeElement.src = __createNaviteURL__(_gCommonServiceUrl,cn.dict.NaitveServiceManager.UIModuleName,actionName,iframeElement.id,jsonString);
    document.body.appendChild(iframeElement);
}

cn.dict.UIManager.ajaxSearch = function(jsonString) {
    var actionName = "ajaxSearch";
    var iframeElement = __createHiddenIFrame__();
    iframeElement.src = __createNaviteURL__(_gCommonServiceUrl,cn.dict.NaitveServiceManager.UIModuleName,actionName,iframeElement.id,jsonString);
    document.body.appendChild(iframeElement);
}

/**
 *
 *  弹出新的一个webkit
 *  {width:弹出宽度,height:弹出高度}
 *
 */
cn.dict.UIManager.popNewWebkit = function(jsonString) {
    var actionName = "popWebkit";
    var iframeElement = __createHiddenIFrame__();
    iframeElement.src = __createNaviteURL__(_gCommonServiceUrl,cn.dict.NaitveServiceManager.UIModuleName,actionName,iframeElement.id,jsonString);
    document.body.appendChild(iframeElement);
}

/**
 *
 *  权限校验
 *  {pid:权限ID,displayMode:没有权限时显示模式(1:native控制显示,2:webkit自己控制，默认为1),successCallback:有权限回调,failureCallback:无权限回调}
 *  pid列表：1001笔顺权限
 *
 */
cn.dict.UIManager.verifyPermission = function(jsonString) {
    var actionName = "verifyPermission";
    var iframeElement = __createHiddenIFrame__();
    iframeElement.src = __createNaviteURL__(_gCommonServiceUrl,cn.dict.NaitveServiceManager.UIModuleName,actionName,iframeElement.id,jsonString);
    document.body.appendChild(iframeElement);
}


//生词本快捷访问对象
var _UIMgr = cn.dict.UIManager;
if(!cn.dict.LessonManager) cn.dict.LessonManager = {}

cn.dict.LessonManager.setItem = function(jsonString) {
//    var fullJsonString = JSON.stringify({'key':key,'value':jsonString});
    var actionName = "setItem";
    var iframeElement = __createHiddenIFrame__();
    iframeElement.src = __createNaviteURL__(_gCommonServiceUrl,cn.dict.NaitveServiceManager.LsManagerModuleName,actionName,iframeElement.id,jsonString);
    document.body.appendChild(iframeElement);
}

cn.dict.LessonManager.getItem = function(jsonString) {
    var actionName = "getItem";
    var iframeElement = __createHiddenIFrame__();
    iframeElement.src = __createNaviteURL__(_gCommonServiceUrl,cn.dict.NaitveServiceManager.LsManagerModuleName,actionName,iframeElement.id,jsonString);
    document.body.appendChild(iframeElement);
}

cn.dict.LessonManager.refreshStudyStatus = function(jsonString) {
    var actionName = "refreshStudyStatus";
    var iframeElement = __createHiddenIFrame__();
    iframeElement.src = __createNaviteURL__(_gCommonServiceUrl,cn.dict.NaitveServiceManager.LsManagerModuleName,actionName,iframeElement.id,jsonString);
    document.body.appendChild(iframeElement);
}

cn.dict.LessonManager.startRecord = function(jsonString) {
    var actionName = "startRecord";
    var iframeElement = __createHiddenIFrame__();
    iframeElement.src = __createNaviteURL__(_gCommonServiceUrl,cn.dict.NaitveServiceManager.LsManagerModuleName,actionName,iframeElement.id,jsonString);
    document.body.appendChild(iframeElement);
}
cn.dict.LessonManager.stopRecord = function(jsonString) {
    var actionName = "stopRecord";
    var iframeElement = __createHiddenIFrame__();
    iframeElement.src = __createNaviteURL__(_gCommonServiceUrl,cn.dict.NaitveServiceManager.LsManagerModuleName,actionName,iframeElement.id,jsonString);
    document.body.appendChild(iframeElement);
}

cn.dict.LessonManager.refreshRecordPath = function(jsonString) {
    var actionName = "refreshRecordPath";
    var iframeElement = __createHiddenIFrame__();
    iframeElement.src = __createNaviteURL__(_gCommonServiceUrl,cn.dict.NaitveServiceManager.LsManagerModuleName,actionName,iframeElement.id,jsonString);
    document.body.appendChild(iframeElement);
}

cn.dict.LessonManager.refreshFavorite = function(jsonString) {
    
    var actionName = "refreshFavorite";
    var iframeElement = __createHiddenIFrame__();
    iframeElement.src = __createNaviteURL__(_gCommonServiceUrl,cn.dict.NaitveServiceManager.LsManagerModuleName,actionName,iframeElement.id,jsonString);
    document.body.appendChild(iframeElement);
}

cn.dict.LessonManager.openLesson = function(jsonString) {
    
    var actionName = "openLesson";
    var iframeElement = __createHiddenIFrame__();
    iframeElement.src = __createNaviteURL__(_gCommonServiceUrl, cn.dict.NaitveServiceManager.LsManagerModuleName,actionName,iframeElement.id,jsonString);
    document.body.appendChild(iframeElement);
}

cn.dict.LessonManager.openPrmSettingPanel = function(jsonString) {
    
    var actionName = "openPrmSettingPanel";
    var iframeElement = __createHiddenIFrame__();
    iframeElement.src = __createNaviteURL__(_gCommonServiceUrl, cn.dict.NaitveServiceManager.LsManagerModuleName,actionName,iframeElement.id,jsonString);
    document.body.appendChild(iframeElement);
}

cn.dict.LessonManager.saveCurrKtIndex = function(jsonString) {
    
    var actionName = "saveCurrKtIndex";
    var iframeElement = __createHiddenIFrame__();
    iframeElement.src = __createNaviteURL__(_gCommonServiceUrl, cn.dict.NaitveServiceManager.LsManagerModuleName,actionName,iframeElement.id,jsonString);
    document.body.appendChild(iframeElement);
}

cn.dict.LessonManager.jumpTrain = function(jsonString) {
    
    var actionName = "jumpTrain";
    var iframeElement = __createHiddenIFrame__();
    iframeElement.src = __createNaviteURL__(_gCommonServiceUrl, cn.dict.NaitveServiceManager.LsManagerModuleName,actionName,iframeElement.id,jsonString);
    document.body.appendChild(iframeElement);
}

// cn.dict.LessonManager.addScb = function(jsonString) {
//     var actionName = "addScb";
//     var iframeElement = __createHiddenIFrame__();
//     iframeElement.src = __createNaviteURL__(_gCommonServiceUrl,cn.dict.NaitveServiceManager.LsManagerModuleName,actionName,iframeElement.id,jsonString);
//     document.body.appendChild(iframeElement);
//     //     var callbackJsonString = JSON.stringify({'uwid':11111,'in_scb':'1'});
//     // onScbSuccess(callbackJsonString);
// }

//课程快捷访问
var _LsMgr = cn.dict.LessonManager;


var dictcn;
if(!dictcn) dictcn = {};
// dictcn.addScb = _ScbMgr.addScb;
dictcn.playSound = _AudioMgr.playSound;
dictcn.searchText = _UIMgr.searchWord;
dictcn.ajaxSearch = _UIMgr.ajaxSearch;
dictcn.popupDict = _DictMgr.popupDict;
dictcn.setItem = _LsMgr.setItem;
dictcn.getItem = _LsMgr.getItem;
dictcn.refreshStudyStatus = _LsMgr.refreshStudyStatus;
dictcn.startRecord = _LsMgr.startRecord;
dictcn.stopRecord = _LsMgr.stopRecord;
dictcn.refreshRecordPath = _LsMgr.refreshRecordPath;
dictcn.refreshFavorite = _LsMgr.refreshFavorite;
dictcn.jumpTrain = _LsMgr.jumpTrain;
dictcn.openLesson = _LsMgr.openLesson;
dictcn.openPrmSettingPanel = _LsMgr.openPrmSettingPanel;
dictcn.saveCurrKtIndex = _LsMgr.saveCurrKtIndex;

// dictcn.addScb = _LsMgr.addScb;

function __getStrokeOrderForPopWebkitSuccessCallback(jsonString) {
    var jsonData = JSON.parse(jsonString);
    if(jsonData["successCallback"]) delete jsonData["successCallback"];
    if(jsonData["failureCallback"]) delete jsonData["failureCallback"];
    if(jsonData["key"]) jsonData["word"] = jsonData["key"];
    _UIMgr.popNewWebkit(JSON.stringify(jsonData));
}

function __verifyPermissionForPopPlayStrokeSuccessCallback(jsonString) {
    var jsonData = JSON.parse(jsonString);
    if(jsonData["successCallback"]) delete jsonData["successCallback"];
    if(jsonData["failureCallback"]) delete jsonData["successCallback"];
    jsonData["successCallback"] = "__getStrokeOrderForPopWebkitSuccessCallback";
    _DictMgr.getStrokeOrder(JSON.stringify(jsonData));
}

dictcn.popPlayStroke = function(jsonString) {
    try{
        var jsonData = JSON.parse(jsonString);
        jsonData["pid"] = 1001;
        jsonData["displayMode"] = 1;
        jsonData["successCallback"] = "__verifyPermissionForPopPlayStrokeSuccessCallback";
        _UIMgr.verifyPermission(JSON.stringify(jsonData));
    }catch(e){}
};

function __getStrokeOrderForPlayStrokeSuccessCallback(jsonString) {
    try{
        var jsonData = JSON.parse(jsonString);
        if(jsonData["startCallback"]) {
            var strokeOrderData = jsonData["strokeOrderData"];
            var callback = jsonData["startCallback"];
            eval("if("+callback+" && typeof("+callback+") == \"function\") {"+callback+"(unescape(\""+escape(JSON.stringify(strokeOrderData))+"\"));}");
        }
    }catch(e){}
}

dictcn.playStroke = function(jsonString) {
    try{
        
        var jsonData = JSON.parse(jsonString);
        jsonData["pid"] = 1001;
        jsonData["displayMode"] = 1;
        jsonData["successCallback"] = "__getStrokeOrderForPlayStrokeSuccessCallback";
        _DictMgr.getStrokeOrder(JSON.stringify(jsonData));
    }catch(e){}
};

//addScb扩展
dictcn.addScb = function (jsonString){
    var jsonData = JSON.parse(jsonString);
    jsonData["successCallback"] = "__addScbSuccessCallBack";
    jsonData["failedCallback"] = "__addScbFailCallBack";
    _ScbMgr.addScb(JSON.stringify(jsonData));
}

function __addScbSuccessCallBack (jsonString) {
    var jsonData = JSON.parse(jsonString);
    if(jsonData["successCallback"]) delete jsonData["successCallback"];
    if(jsonData["failedCallback"]) delete jsonData["failedCallback"];
    jsonData["in_scb"] = "1";
    onScbSuccess(JSON.stringify(jsonData));
}
function __addScbFailCallBack (jsonString) {
    var jsonData = JSON.parse(jsonString);
    if(jsonData["successCallback"]) delete jsonData["successCallback"];
    if(jsonData["failedCallback"]) delete jsonData["failedCallback"];
    jsonData["in_scb"] = "0";
    onScbSuccess(JSON.stringify(jsonData));
}

