var lastIndex = -1, curIndex = -1; //记录上次打开和当前打开的句子
var isRecord = 0; //正在录音
var isPlayingAll = 0; //是否正在播放全部例句声音
var swiperMain,scrollContainer = []; //swiper对象

$(function(){
	var isSwipering;
	var $innerCon = $('.innerContent');
	//页面设置初始化
	function settingInit(){
		getStorage({"key":pageID, "successCallback":"onPageID"});
	}
	//框架尺寸调整方法
	function fixPageHeight(){
		var height = $(window).height() - $('#nav').height();
		$(".swiper-main").css('height', height);
		$(".scroll-container").css('height', height);
		$("#footer").css('width', $(window).width());
		var newHeight = height - $("#footer").height();
		$(".swiper-scrollbar").css('height', newHeight);
	}

	init(); //调用全局初始化函数
	function init(){
		FastClick.attach(document.body);

		//定义框架尺寸
		$(window).on('resize',fixPageHeight);
		fixPageHeight();

		//初始化滑动组件
		swiperMain = new Swiper('.swiper-main',{
			mousewheelControl : true,
			onSlideChangeStart: function(swiper){
				$('#nav span').removeClass('active');
				$('#navbtn'+swiper.activeIndex).addClass('active');
				isSwipering = 1;
				setTimeout(function(){isSwipering = 0;},50);
				$.commFun.clickConflictTest();
			}
		});

		$('.scroll-container').each(function(){
			var sc = $(this).swiper({
				scrollContainer: true,
				mousewheelControl : true,
			    mode:'vertical',
			    scrollbar: {
			      container: '.swiper-scrollbar'
			    }
			});
			scrollContainer.push(sc);
		});
		
		settingInit(); // 页面设置初始化

		showSenInit(); //句子弹开初始化

		//绑定nav点击事件
		$('#nav span').on('click',function(){
			swiperMain.swipeTo($(this).attr('index'));
		});

		//绑定单元练习按钮点击事件
		$('#zhongri').on('click',function(){
			$.commFun.clickConflictTest();
			openLesson({"lesson_key": pageID});
		});

		//绑定设置图标点击事件
		$('#optionBtn').on('click',function(){
			$.commFun.clickConflictTest();
			openPrmSettingPanel();
		});

		audioPlayInit(); //音频播放功能初始化

		audioRecordInit(); //录音与播放录音初始化

		addScbInit(); //添加生词本初始化
	}

	
	function showSenInit(){
		//为每条句子绑定click事件
		$('#dialogueSlide .swiper-wrapper').on('click','.sentence',function(){
			if(!isSwipering){
				$.commFun.clickConflictTest();
				$.commFun.showSentence(this);
			}
		});
	}


	//音频播放功能初始化
	function audioPlayInit(){
		//为播放按钮增加侦听器事件
		$innerCon.on('click','.playSound',function(e){
			e.stopPropagation();
			var skipPause = 0;
			if(isPlayingAll){
				skipPause = 1;
			}
			if(!$.audioPlayer.isHandleMe(this) || $.audioPlayer.ifAdpPaused() || isPlayingAll){ //中间的条件例如录音时点播放
				$.commFun.clickConflictTest(); //冲突检测
			}
			$.audioPlayer.setQueuePlayOff(0); //将队列播放开关参数重置
			if($.audioPlayer.isHandleMe(this)){
				if(!skipPause){ //如果是全局播放，那么冲突检测阶段就会停止播放声音，不需要这一步重复停止
		        	if($.audioPlayer.ifAdpPaused()){
		        		var pro = $.audioPlayer.getProgress();
		        		if(!auth && (pro < 0.02 || (isNaN(pro) && $.audioPlayer.getDuration() <= 0) || pro == 1) && !$.audioPlayer.getArgTracePlay()){ //未激活，且音频处于开始位置
		        			if(!this.reqauth){ //未处于请求权限状态
		        				this.reqauth = 1;
		        				requestSoundAuth({"uwid": $(this).next().attr('id'), "callbackType": "1"});
		        			}
		        			return;
		        		}
		        		$.audioPlayer.play();
		        		return;
		        	}
		        	$.audioPlayer.pause();
		        }
	        }
	        else {
	        	if(!auth){
	        		if(!this.reqauth){ //未处于请求权限状态
	        			this.reqauth = 1;
        				requestSoundAuth({"uwid": $(this).next().attr('id'), "callbackType": "2"});
        			}
        			return;
	        	}
	        	$.commFun.loadNewAudio(this,1);
	        }
		});
		
		$('#playAllSound').click(function(){
			$.commFun.playAllSoundInit();
		});
	}

	//录音与播放录音初始化
	function audioRecordInit(){
		$innerCon.on('click','.recordSound',function(e){
			e.stopPropagation();
			if(!isRecord){
				$.commFun.clickConflictTest();
			}
			var uwid = $(this).attr('id');
			var json = {'uwid': uwid};
			if(!this.state){
				this.state = 1;
				if(!isRecord){
					startRecord(json);
				}
				else {
					json.invaild = 1;
					stopRecord(json);
					$.commFun.closeAutoStopRecord();
				}
			}
		});
		//为录音播放按钮添加监听事件
		$innerCon.on('click','.listenSound',function(e){
	        e.stopPropagation();
	        if(!$.audioPlayer.isHandleMe(this) || $.audioPlayer.ifAdpPaused()){
				$.commFun.clickConflictTest(); //冲突检测
			}
	        if($.audioPlayer.isHandleMe(this)){
	        	$.audioPlayer.playOrPause();
	        }
	        else {
	        	$.commFun.setPlayQueue([]);
		        var url = $.commFun.getRecordAudioPath(curIndex);
	        	$(this).audioPlayer({"url":url, "autoPlay":1, "callbackType":2});
	        }
	    });
	}

	//添加生词本按钮初始化
	function addScbInit(){
		$innerCon.on('click','.addStar',function(e){
			e.stopPropagation();
			$.commFun.clickConflictTest();
			var uwid = $(this).parent().find('.recordSound').attr('id');
			var json = {'uwid': uwid};
			addScb(json);
		});
	}

});
